package com.primeton.gateway.controller;

import com.primeton.gateway.model.RDate;
import com.primeton.gateway.model.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.*;

import java.util.Date;

import static com.primeton.gateway.utils.LocalHostAddress.getLocalHostAddress;

/**
 * @Author zhaozw
 * @ClassName DemonstrationController
 * @Date 2023/4/27 09:33
 * @Description
 */
@RestController
@Api(tags = "插件示范")
@RequestMapping(value = "plugin")
public class DemonstrationController {

    @ApiOperation(value = "带参User，返回当前服务ip、访问时间json")
    @PostMapping("rDate")
    public RDate rDate(@RequestBody User user) {
        RDate rDate = new RDate();
        rDate.setDate();
        rDate.setIp(getLocalHostAddress());
        return rDate;
    }

    @ApiOperation(value = "暂时五秒返回当前时间")
    @GetMapping("sleep")
    public Date sleep() throws InterruptedException{
        Thread.sleep(5000);
        return new Date();
    }

}
