package com.primeton.gateway.utils;

import org.springframework.context.annotation.Configuration;

import java.net.*;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;

/**
 * @Author zhaozw
 * @ClassName LocalHostAddress
 * @Date 2023/4/28 09:25
 * @Description
 */
public class LocalHostAddress {

    public static String getLocalHostAddress() {
        Enumeration<?> netInterfaces;
        List<NetworkInterface> netlist = new ArrayList<NetworkInterface>();
        try {
            //获取当前环境下的所有网卡
            netInterfaces = NetworkInterface.getNetworkInterfaces();
            while (netInterfaces.hasMoreElements()) {
                NetworkInterface ni = (NetworkInterface) netInterfaces.nextElement();
                if (ni.isLoopback()) {
                    continue;//过滤 lo网卡
                }
                //倒置网卡顺序
                netlist.add(0, ni);
            }  /*
                  用上述方法获取所有网卡时，得到的顺序与服务器中用ifconfig命令看到的网卡顺序相反，
                  因此，想要从第一块网卡开始遍历时，需要将Enumeration<?>中的元素倒序 */
            //遍历每个网卡
            for (NetworkInterface list : netlist) {
                //获取网卡下所有ip
                Enumeration<?> cardipaddress = list.getInetAddresses();
                //将网卡下所有ip地址取出
                while (cardipaddress.hasMoreElements()) {
                    InetAddress ip = (InetAddress) cardipaddress.nextElement();
                    if (!ip.isLoopbackAddress()) {
                        if ("127.0.0.1".equalsIgnoreCase(ip.getHostAddress())) {
                            continue;
                        }
                        //过滤ipv6地址
                        if (ip instanceof Inet6Address) {
                            continue;
                        }
                        //返回ipv4地址
                        if (ip instanceof Inet4Address) {
                            return ip.getHostAddress();
                        }
                    }
                    //默认返回
                    return InetAddress.getLocalHost().getHostAddress();
                }

            }
        } catch (SocketException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return "";
    }
}
