#!/bin/sh

PRG="$0"
saveddir=`pwd`
DAP_HOME=`dirname "$PRG"`/..
DAP_HOME=`cd "$DAP_HOME" && pwd`
cd "$saveddir"

export APP_NAME=API-GATEWAY-TEST
export MODE=service
export LOG_FOLDER="${DAP_HOME}"/logs
export PID_FOLDER="${LOG_FOLDER}"
export LOG_FILENAME="${APP_NAME}.out" # log console for background mode running

mkdir -p $LOG_FOLDER/$APP_NAME

rm -fr $LOG_FOLDER/$LOG_FILENAME
ln -s /dev/null $LOG_FOLDER/$LOG_FILENAME             # "$LOG_FOLDER/$LOG_FILENAME is using for >> "$log_file" 2>&1"
export JAVA_OPTS="$JAVA_OPTS -Dlogging.file=$LOG_FOLDER/${APP_NAME}.log"

#SW_OPTS=" -javaagent:/opt/demo/gateway-order/agent/skywalking-agent.jar -DSW_AGENT_NAME=ORDER-MANAGE-POC -DSW_AGENT_COLLECTOR_BACKEND_SERVICES=10.16.16.212:11800 -Dskywalking.trace.ignore_path=/eureka/**,/actuator/**,/**/api-access-stats** "

export JAVA_OPTS=" $JAVA_OPTS -server -Djava.net.preferIPv4Stack=true -Duser.timezone=Asia/Shanghai -Dclient.encoding.override=UTF-8 -Dfile.encoding=UTF-8 -Djava.security.egd=file:/dev/./urandom"
export JAVA_OPTS="$JAVA_OPTS $DAP_MEM_OPTS"
export JAVA_OPTS="$JAVA_OPTS -XX:+HeapDumpOnOutOfMemoryError"
export JAVA_OPTS="$JAVA_OPTS -Dloader.path=${DAP_HOME}/lib"
# export JAVA_OPTS="$JAVA_OPTS -XX:+UseParNewGC -XX:ParallelGCThreads=4 -XX:MaxTenuringThreshold=9 -XX:+UseConcMarkSweepGC"
if [ "$1" = "-debug" ]
then
    export JAVA_OPTS="${JAVA_OPTS} -Xrunjdwp:transport=dt_socket,server=y,suspend=n,address=8788"
fi

action=$1
if [[ "$action" == "run" ]] || [[ "$action" == "start" ]]; then
  shift
else
  action="start"
fi
BOOT_JAR=`echo "${DAP_HOME}"/*.jar`
$BOOT_JAR $action "$@"

